
/*
 * cs_example.h
 *
 * Generic include file for the Collation Kit example.
 */


/* Character Set ID for the example character set */
#define CS_EXAMPLE_CHARSET_ID   251

/* Collation ID for the example collation */
#define LC_EXAMPLE_COLLATE_ID   250

#define MAX_KEY         254 /* XXX */


/* Generic InterBase data type definitions */

typedef char            SCHAR;
typedef unsigned char   UCHAR;
typedef short           SSHORT;
typedef unsigned short  USHORT;
typedef long            SLONG;
typedef unsigned long   ULONG;

typedef unsigned char   BYTE;

#define CONST   const

#ifndef NULL
#define NULL    ((void *)0)
#endif


#ifdef _BORLAND_C_
#define EXPORT	__export
#endif

#ifndef EXPORT
#define	EXPORT
#endif

#ifndef FAR_VARIABLE
#define FAR_VARIABLE
#endif

#ifndef FALSE
#define FALSE   (0)
#define TRUE    (1)
#endif

#define MIN(a,b)    (((a) < (b)) ? (a) : (b))


/* InterBase memory management structure - do not modify */

typedef struct blk {
    UCHAR       blk_type;
    UCHAR       blk_pool_id_mod;
    USHORT      blk_length;
} *BLK;


/* InterBase - general purpose vector */

typedef struct vec {
    struct blk  vec_header;
    ULONG       vec_count;
    struct blk  *vec_object [1];
} *VEC;

#include "charsets.h"



/* XXX -- ouch!  These values may be different between versions!
   See source/jrd/blk.h
   */

#define type_texttype 54
#define type_charset 55
#define type_csconvert 56

typedef unsigned short UNICODE;

#define assert(x)   /* nothing for now */


#include "intlobj.h"



/* cs_example.sql */

void  CV_convert_init();
USHORT  CV_nc_to_unicode();
USHORT  CV_unicode_to_nc();
