
#include "cs_example.h"


/* Note: Cannot use a lookup table here as SUN4 cannot init pointers inside
 * shared libraries
 */


extern USHORT   CS_example_init();
extern USHORT   LC_win1252_example();


/* On Windows, this must export as the symbol "LD2_lookup" or "_LD2_lookup" */

USHORT EXPORT LD2_lookup (
    USHORT	objtype,
    FPTR_SHORT	*fun,
    SSHORT	parm1,
    SSHORT	parm2)
{
/**************************************
 *
 *	L D 2 _ l o o k u p
 *
 **************************************
 *
 * Functional description
 *
 *	Lookup an international object implementation via object type
 *	and id (one id for charsets & collations, two ids for converters).
 *
 *	Note: This routine is a cousin of intl/ld.c:LD_lookup
 *
 * Return:
 *	If object implemented by this module:
 *		(fun)	set to the object initializer
 *		0	returned
 *	Otherwise:
 *		(fun)	set to nil.
 *		1	returned
 *
 **************************************/

switch (objtype)
    {
    case type_texttype:
	switch ((unsigned short)parm1)
	    {
		/* This is the example character set for WIN1252 */
	    case (LC_EXAMPLE_COLLATE_ID << 8) | CS_WIN1252: 
                *fun = LC_win1252_example;
                 return 0;

		/* This is the default collation for the example charset */
	    case (0 << 8) | CS_EXAMPLE_CHARSET_ID: 
                *fun = LC_win1252_example;
                 return 0;

	    default:
		*fun = (FPTR_SHORT) NULL;
		return 1;

	    };
    case type_charset:
	switch (parm1)
	    {
	    case CS_EXAMPLE_CHARSET_ID:
                *fun = CS_example_init;
                 return 0;
	    default:
		*fun = (FPTR_SHORT) NULL;
		return 1;
	    };
    case type_csconvert:
	{
	*fun = (FPTR_SHORT) NULL;
	return 1;
	}
    default:
        /* Fall through to error case */
        break;
    }
*fun = (FPTR_SHORT) NULL;
return 1;
}
